// @flow
export function getLabelFromPath(path: *, t: *) {
  return getIdentifierName(path, t)
}

function getDeclaratorName(path, t) {
  // $FlowFixMe
  const parent = path.findParent(p => p.isVariableDeclarator())
  return parent && t.isIdentifier(parent.node.id) ? parent.node.id.name : ''
}

function getIdentifierName(path, t) {
  let classParent
  if (path) {
    // $FlowFixMe
    classParent = path.findParent(p => t.isClass(p))
  }
  if (classParent && classParent.node.id) {
    return t.isIdentifier(classParent.node.id) ? classParent.node.id.name : ''
  }

  let declaratorName = getDeclaratorName(path, t)
  // if the name starts with _ it was probably generated by babel so we should ignore it
  if (declaratorName.charAt(0) === '_') {
    return ''
  }
  return declaratorName
}
